unit Glissando1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, LCLtype,
		ComCtrls, ExtCtrls, BASS, math;

type

		{ TForm1 }

  TForm1 = class(TForm)
				Button1: TButton;
				Button2: TButton;
				Image1: TImage;
				Label2: TLabel;
				RadioGroup1: TRadioGroup;
				TrackBar1: TTrackBar;
				procedure Button1Click(Sender: TObject);
				procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CaptionFreq;
				procedure TrackBar1Change(Sender: TObject);

  private

  public

  end;


const KammertonA = 28160; // entspricht 440 Hertz=Kammerton a

var
  Form1: TForm1;
  info: bass_info;
  stream : dword;
  channel: Dword;
  freq  : dword = KammertonA;
  data : array[0..127] of smallInt;
  sample : Dword;

implementation
{$R *.lfm}


procedure BassInit(H: HWND);
begin
{$IFDEF LINUX}
BASS_Init(-1, 44100, 0, @H, nil);
{$ELSE}
BASS_Init(-1, 44100, 0, H, nil); /// !!! Bei Windows ohne Pointer, nur Handle
{$ENDIF}
end;


procedure createSinus;
var a : byte;
begin
for a := 0 to 127 do data[a] := round(32767* sin(a)*pi*2/64);
end;


procedure createRect;
var a : byte;
v : smallInt;

begin
v := round (32767*pi*2/64);
for a := 0 to 127 do if a < 64 then data[a] := -v else data[a] := v;
end;

procedure CreateSawTooth;
var a : byte;
v : smallInt;
begin
v := round (32767*pi*2/64);
for a := 0 to 127 do data[a] := v - 2*a *v div 127;
end;

Procedure PlayEnvelope;
begin
channel := BASS_SampleGetChannel(sample,false);
BASS_ChannelPlay(channel, false);
end;

procedure TForm1.CaptionFreq;
var i,p, dx : Integer;
    s: string;
    step : single = 55/2;
begin
Image1.Canvas.Brush.Color := clWhite;
Image1.Canvas.FillRect(0,0,Image1.Width, Image1.height);
Image1.Canvas.TextOut(1,1,'Hertz');
for i := 0 to 7 do
  begin
  p := Image1.width *i div 8;
  with Image1.canvas do
    begin
    if i in [1..7] then
    begin
    Line(p,0,p,20);
    step  := step * 2;
    s := IntToStr(round(step));
    dx := TextWidth(s) div 2;
    textout(P-dx,20,s);
				end;
		end; // with
  end;  // for
end;



procedure TForm1.TrackBar1Change(Sender: TObject);
var  frequency : single;

begin
frequency := Power(2,4.8+Trackbar1.Position/Trackbar1.Max*8);
Label2.Caption:=  IntToStr(round(frequency))+' Hz';
BASS_ChannelSlideAttribute(Channel,BASS_ATTRIB_FREQ,frequency/440*KammertonA,100);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 BassInit(Handle);
 CaptionFreq;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
Button2.enabled := true;
Button1.Enabled := false;
RadioGroup1.enabled := false;
freq := KammertonA;
TrackBar1.Position:= TrackBar1.max div 2;
sample := BASS_SampleCreate(256,freq,1,1,BASS_SAMPLE_LOOP or BASS_SAMPLE_OVER_POS);
case RadioGroup1.ItemIndex of
0 : createSinus;
1:  createRect;
2: CreateSawTooth;
end;
BASS_SampleSetData(sample,@data) ;
PlayEnvelope;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  BASS_ChannelStop(channel);
  Button1.enabled := true;
  Button2.Enabled := false;
  RadioGroup1.enabled := true;
end;

end.

